
###############get age info
wl.data<-read.csv("D:/Fei/umich2013/kecc/WaitListing/Feb2015/WaitListing_State_age.csv")
head(wl.data)
names(wl.data)
table(wl.data[,1])

wl.data$state<-substr(wl.data[,1],1,2)
table(wl.data$state)

wl.mi.age<-wl.data[wl.data$state=="MI",]

wli = wl.mi.age
dim(wli)
Timeafttxp<-wli$surv_time-wli$txp_time
hist(Timeafttxp,main='Time after Transplant for Michigan')
#Timeafttxp[is.na(Timeafttxp)]<-9999
table(wli$surv_time<wli$txp_time)
wl<-rbind(wli[(Timeafttxp>=0)&(!is.na(Timeafttxp)),],wli[is.na(Timeafttxp),])
head(wl)
Timeafttxp<-wl$surv_time-wl$txp_time
hist(Timeafttxp,main='Time after Transplant for Michigan')
table(Timeafttxp>=0)
wl$txp<-1-is.na(wl$txp_time)
table(wl$txp)

write.csv(wl,"Waitinglist_MI_AGE.csv")

table(is.na(rownames(wl)))

#wl.mi<-wl
#wl1<-wl.mi
wl1<-wl
n1<-dim(wl1)[1]
wl1$t2<-wl1$t1<-0
for(i in 1:n1){
  if (wl1$txp[i]==1 & wl1$txp_time[i]>0){
    wl1$t2[i]<-wl1$txp_time[i]
    add1<-wl1[i,]
    add1$t1<-add1$t2
    add1$t2<-add1$surv_time
    wl1$txp[i]<-0
    wl1<-rbind(wl1,add1)
  } else {
    wl1$t2[i]<-wl1$surv_time[i]
  }
}
tail(wl1) ###########extented data with age
range(wl1$surv_time,na.rm=T)
range(wl1$txp_time,na.rm=T)
table(wl1$surv_time>=wl1$txp_time)
head(cbind(wl1$t1,wl1$t2))
wl1[wl1$t1==wl1$t2,]
plot(wl1$txp_time,wl.mi.z$txp_time)
identical(wl$txp_time,wl.mi$txp_time)
##############traiditional cox model
library(survival)
names(wl1)
y1 = wl1$t1
y2 = wl1$t2
y2[y2==y1]<-y2[y2==y1]+0.5
status = wl1$died
table(status)
Z1 = wl1$can_bmi_0c 
table(wl1$CAN_GENDER)
Z2 = as.numeric(wl1$CAN_GENDER=="F")

table(wl1$can_malig_0cc)
wl1$can_malig_Y<-(wl1$can_malig_0cc=="Y")
table(wl1$can_malig_Y)
Z3 = as.numeric(wl1$can_malig_Y)
Z4 = wl1$can_max_cold_tm_0c

table(wl1$can_diab_comb)
wl1$can_diab_1<-(wl1$can_diab_comb==1)
Z5 = as.numeric(wl1$can_diab_1)
Z0<-wl1$CAN_AGE_IN_MONTHS_AT_LISTING/12
Z<-cbind(Z0,Z1,Z2,Z3,Z4,Z5)

head(Z)
summary(Z1[Z1>0])
table(Z3)
hist(Z4)
range(Z4)
table(Z5)

table(wl1$txp)
cox1<-coxph(Surv(y1,y2,status)~wl1$txp+Z)
summary(cox1)
pne<-predict(cox1,type="expected")
boxplot(pne~wl1$txp)
boxplot(pne~status+wl1$txp)
boxplot(pne~status+wl1$txp,names=c("censored & no tx","dead & no tx","censored & tx","dead & tx"),
        ylim=c(0,0.5),ylab="prediction",main="Prediction by status and transplantation")

coefest<-summary(cox1)$coef
rownames(coefest)<-c("TXP","Age","BMI","Female","PM","MACIT","Diab")
coefest
coefsd<-coefest[,1]/coefest[,4]
signif(coefsd,2)
write.csv(round(coefest,3),"traditionalCox.csv")
wl1.mi.z<-data.frame(y1,y2,status,Z)
head(wl1.mi.z)
hist(wl1.mi.z[,2])
write.csv(wl1.mi.z,"WL_MI_Z.csv")
getwd()

###############No transplantation
wl.noTX<-wl.mi[wl.mi$txp==0,]
y<-wl.noTX$surv_time
status = wl.noTX$died
table(status)
Z1 = wl.noTX$can_bmi_0c 
table(wl.noTX$CAN_GENDER)
Z2 = as.numeric(wl.noTX$CAN_GENDER=="F")

table(wl.noTX$can_malig_0cc)
wl.noTX$can_malig_Y<-(wl.noTX$can_malig_0cc=="Y")
table(wl.noTX$can_malig_Y)
Z3 = as.numeric(wl.noTX$can_malig_Y)
Z4 = wl.noTX$can_max_cold_tm_0c

table(wl.noTX$can_diab_comb)
wl.noTX$can_diab_1<-(wl.noTX$can_diab_comb==1)
Z5 = as.numeric(wl.noTX$can_diab_1)
Z<-cbind(Z1,Z2,Z3,Z4,Z5)

cox.noTX<-coxph(Surv(y,status)~Z)
summary(cox.noTX)
p.noTX<-predict(cox.noTX,type="expected")
boxplot(p.noTX~status,xlab="status",ylab="prediction",main="Prediction for no TX subjects")

boxplot(y~status)
boxplot(lung$time~lung$status)
