
GPLE_adp<-GPLE_adp_resample<-function(Z,ti,y,status,alpha,initial,q,itera)
{
  
  n<-length(y)
  rG<-rexp(n,1)
  ftime<-sort(y[status==1])
  fd<-length(ftime)
  failure<-round(q*fd)
  time<-sort(unique(y[status==1]))
  d<-length(time)
  risk<-(outer(y,rep(1,d))>=outer(rep(1,n),time))
  STATUS<-status*(outer(y,rep(1,d))==outer(rep(1,n),time))
  M1<-outer(ti,rep(1,d))<=outer(rep(1,n),time)
  timeTT<- -outer(ti,rep(1,d))+outer(rep(1,n),time)
  BETA<-T0<- unique(round(sort(abs(c(timeTT[abs(timeTT)<9999]))),2))
  
  #plot(T0,rep(0,length(T0)),type="l",ylim=c(-10,10))
  
  score<- rep(1,2)*0
  imat<-outer(score,score)*0
  GBETA<-initial
  GBETA1<-GBETA+1
  alpha1<-alpha+1
  theta<-theta0<-c(0,0)
  r<-1
  #rrr<-floor(length(T0)/40)
  #rrru<-floor(length(T0)/10)
  #rrruu<-floor(length(T0)/2)
  rrr0<-20
  while((max(abs(alpha1-alpha))+max(abs(GBETA-GBETA1))>itera)&(r<=rrr0))
  {
    
    GBETA1<-GBETA
    #nonparametric
    #h<-h1
    j<-1
    az<-c(alpha%*%t(Z))
    bandwidth<-NULL
    while (j<=min(1600,length(T0)))
    {
      s<-1
      while((ftime[s]<=T0[j])&s<fd) s=s+1
      if (s<=failure/2) {
        hl<-0
        hr<-ftime[failure]
        h<-hr-hl
      }  else if ((fd-s)<=failure/2) {
        hl<-ftime[fd-failure]
        hr<-max(ftime)
        h<-hr-hl
      }  else {
        hl<-ftime[s-floor(failure/2)]
        hr<-ftime[s+floor(failure/2)]
        h<-hr-hl
      }
      bandwidth<-c(bandwidth,h)
      #if (j%%100==0)  print(h)
      
      wei1<-3/4*(1-(timeTT-T0[j])^2/(h^2))*(abs(timeTT-T0[j])<=h)/h+0.00001 ####Kernal fn.
      fenmu<- c(rG%*%(risk*exp(az)*exp(M1*GBETA)))   #############3.1 denominator
      fenmu<-(fenmu==0)*1e-05+fenmu*(fenmu!=0)
      fenzi3<- exp(az)*exp(M1*GBETA*(1-h*wei1)) 
      fenzi11<-risk*(wei1*M1)               ##############w1
      fenzi12<-risk*(wei1*(timeTT-T0[j])*M1) ##############w2
      part11<-sum(STATUS*rG*(wei1*M1))           ######before minus sign for delta
      part12<-sum(STATUS*rG*(wei1*M1*(timeTT-T0[j])))   ##########before minus sign for ita
      
      theta1<-theta+1
      while(sum(abs(theta1-theta))>=0.001)
      {
        theta1<-theta
        fenzi2<-exp(theta[1]*h*wei1*M1 +theta[2]*h*wei1*(timeTT-T0[j])*M1)#######exp(psai*w)
        
        fenzi<-c(rG%*%(fenzi11*fenzi2*fenzi3))
        score[1]<-part11-sum(c(STATUS%*%c(fenzi/fenmu)))
        
        fenzi<-c(rG%*%(fenzi12*fenzi2*fenzi3))
        score[2]<-part12-sum(c(STATUS%*%c(fenzi/fenmu)))
        
        fz<- h*c(rG%*%(fenzi11*fenzi11*fenzi2*fenzi3))
        imat[1,1]<- -sum(c(STATUS%*%c(fz/fenmu)))
        
        fz<- h*c(rG%*%(fenzi11*fenzi12*fenzi2*fenzi3))
        imat[1,2]<-imat[2,1]<- -sum(c(STATUS%*%c(fz/fenmu)))
        
        fz<- h*c(rG%*%(fenzi12*fenzi12*fenzi2*fenzi3))
        imat[2,2]<- -sum(c(STATUS%*%c(fz/fenmu)))
        theta<-theta-c(solve(imat)%*%score)
        if (j%%200==0)  print(c(h,j,theta))
      }
      GBETA[round(timeTT,2)==T0[j]]<-theta[1]
      BETA[j]<-theta[1]
      #lines(T0[rrr:j],BETA[rrr:j])
      j<-j+1
    }
    
    
    #plot(T0[1:1600],BETA[1:1600])
    
    #Parametric
    alpha1<-alpha
    pscore<-alpha*0
    pimat<-outer(pscore,pscore)
    #ppart1<-sum(STATUS*Z1)
    #ppart2<-sum(STATUS*Z2)
    ppart<-rowSums(t(Z)%*%(STATUS*rG))
    fenmu<- c(rG%*%(risk*exp(az)*exp(M1*GBETA)))
    fenmu<-(fenmu==0)*1e-05+fenmu*(fenmu!=0)
    #pfenzi1<- c(rep(1,n)%*%(risk*Z1*exp(az)*exp(M1*GBETA)))
    #pfenzi2<- c(rep(1,n)%*%(risk*Z2*exp(az)*exp(M1*GBETA)))
    pfenzi<-(t(Z)%*%(rG*risk*exp(az)*exp(M1*GBETA)))
    
    #pscore[1]<-ppart1-sum(c(STATUS%*%c(pfenzi1/fenmu)))
    #pscore[2]<-ppart2-sum(c(STATUS%*%c(pfenzi2/fenmu)))
    pscore<-ppart-colSums((STATUS*rG)%*%(t(pfenzi)/fenmu))
    
    for (i in 1:ncol(Z)){
      ppfenzi<-t(Z*Z[,i])%*%(rG*risk*exp(az)*exp(M1*GBETA))
      use1<-colSums((STATUS*rG)%*%(t(ppfenzi)/fenmu))
      use2<-colSums((STATUS*rG)%*%(t(pfenzi)*pfenzi[i,]/fenmu^2))
      pimat[i,]<-use2-use1
    }
    
    alpha<-alpha-c(solve(pimat)%*%pscore)
    print(alpha)
    r<-r+1
    print(r)
    print(max(abs(alpha1-alpha))+max(abs(GBETA1-GBETA)))
  }
  ab<-c(max(abs(alpha1-alpha)),max(abs(GBETA1-GBETA)))
  if(max(abs(alpha1-alpha))+max(abs(GBETA1-GBETA))<=itera)
    return(list(T0[T0<=1600],alpha,BETA[T0<=1600],ab,bandwidth,rG))
  if(max(abs(alpha1-alpha))+max(abs(GBETA1-GBETA))>itera)
    return(list(T0[T0<=1600],alpha*0,BETA[T0<=1600]*0,ab,bandwidth,rG))
}
