getwd()
save.image("fitMI_resample.RData")

itera.diff<-matrix(nrow=200,ncol=2)
randomGs<-matrix(nrow=200,ncol=n)
ALPHA<-matrix(nrow=200,ncol=ncol(Z))
BETA.all<-matrix(nrow=200,ncol=1800)
plot(T0,rep(0,length(T0)),type="l",ylim=c(-5,5),ylab='BETA')

for(j in 2:200){
  fit2<-GPLE_adp_resample(Z,ti,y,status,alpha,initial,0.15,0.01)
  
  ALPHA[j,]<-fit2[[2]]
  timepoints<-fit2[[1]]+1
  BETA.all[j,timepoints]<-fit2[[3]]
  smooth<-loess(fit2[[3]]~fit2[[1]], span = 1/10, degfit2 = 2)
  BETA.all[j,is.na(BETA.all[j,])]<-predict(smooth,seq(1:1800)[is.na(BETA.all[j,])])
  lines(smooth)
  itera.diff[j,]<-fit2[[4]]
  randomGs[j,]<-fit2[[6]]
  print(j)
  write.table(ALPHA,file = "outALPHA")
  write.table(itera.diff,file = "outiteradiff")
  write.table(randomGs,file = "outGs")
  write.table(BETA.all,file = "outBETA")
}

ALPHA<-read.table(file = "outALPHA")
randomGs<-read.table(file = "outGs")
BETA.all<-read.table(file = "outBETA")

tail(ALPHA)
n.bootstrap=200
mean_alpha<-colMeans(ALPHA[1:n.bootstrap,])
sd_alpha<-rep(0,ncol(Z))
for (i in 1:ncol(Z)){
  sd_alpha[i]<-sd(ALPHA[1:n.bootstrap,i])
}
mean_alpha
sd_alpha
z_alpha<-mean_alpha/sd_alpha
p_alpha<-signif((1-pnorm(abs(z_alpha)))*2,3)
alpha.tab<-cbind(mean_alpha,sd_alpha,p_alpha)
write.csv(signif(alpha.tab,2),"alpha_table.csv")

CI_ALPHA_u<-mean_alpha+1.96*sd_alpha
CI_ALPHA_l<-mean_alpha-1.96*sd_alpha
CI_ALPHA<-rbind(CI_ALPHA_l,CI_ALPHA_u)


#BETA.all[1:48,1601:1602]

Beta<-BETA.all[1:n.bootstrap,1:1600]
dim(Beta)
beta_mean<-colMeans(Beta)
beta_sd<-apply(Beta,2,sd)
beta_u<-beta_mean+1.96*beta_sd
beta_l<-beta_mean-1.96*beta_sd
ss_mean<-smooth.spline(fit1[[1]],beta_mean,df=20)
ss_u<-smooth.spline(fit1[[1]],beta_u,df=20)
ss_l<-smooth.spline(fit1[[1]],beta_l,df=20)

beta_u[115:121]

plot(T0,rep(0,length(T0)),type="l",xlim=c(0,1600),ylim=c(-4,2),ylab=expression(beta(t-ti)), xaxt = "n",
     main="Estimated Transplantation Effect",xlab="time after transplant")
lines(ss1)
lines(ss_mean,lty=2)
lines(ss_u,lty=3)
lines(ss_l,lty=3)
legend("topright",legend=c("Estimate","Bootstrap Mean","Bootstrap confidence band"),
       lty=c(1,2,3))
abline(v = c(115,975), lty=3)
axis(1, at=c(0,115,975,1500))
